widget_vincentdjango/assignments/urls.py
from django.urls import path
from .views import homeAssignmentsPage, AssignmentsDetailView, AssignmentsUpdateView, AssignmentsCreateView

urlpatterns = [
    path('', homeAssignmentsPage, name='homePage'),
    path('add/', AssignmentsCreateView.as_view(), name='assignment_add'),
    path('<int:pk>/details/', AssignmentsDetailView.as_view(), name='assignment_details'),
    path('<int:pk>/edit/', AssignmentsUpdateView.as_view(), name='assignment_update'),
]

app_name = "assignments"

widget_vincentdjango/forum/urls.py
# forum/urls.py
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

# This might be needed, depending on your Django version
app_name = "forum"

widget_vincentdjango/widget_calendar/urls.py
from django.urls import path
from .views import index, EventDetailView, EventCreateView, EventUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('events/<int:pk>/details', EventDetailView.as_view(), name='event-details'),
    path('events/add', EventCreateView.as_view(), name='event-add'),
    path('events/<int:pk>/edit', EventUpdateView.as_view(), name='event-edit'),

]

app_name = "calendar"

widget_vincentdjango/widget_vincentdjango/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('dashboard.urls', namespace="dashboard")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
]

widget_vincentdjango/widget_calendar/models.py
from django.db import models
from django.urls import reverse
from datetime import datetime
from assignments.models import Course


class Location(models.Model):
    mode = models.CharField(max_length=100, default="")
    venue = models.CharField(max_length=100, default="")

    def __str__(self):
        return '{} {}'.format(self.mode, self.venue)


class Event(models.Model):
    target_datetime = models.DateTimeField(default=datetime.now())
    activity = models.CharField(max_length=100, default="")
    estimated_hours = models.FloatField(default=0)
    course = models.ForeignKey(
        Course,
        on_delete=models.CASCADE,
    )
    location = models.ForeignKey(
        Location,
        on_delete=models.CASCADE,
        related_name='venues'
    )

    def __str__(self):
        return "{} {} {} {}".format(self.target_datetime, self.activity, self.estimated_hours, self.location)

    def get_absolute_url(self):
        return reverse('calendar:event-details', kwargs={'pk': self.pk})

widget_vincentdjango/widget_calendar/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import Event, Location


def index(request):
    events = Event.objects.all()
    return render(request, 'calendar/calendar.html',
                  {'events': events, })


class EventDetailView(DetailView):
    model = Event
    template_name = 'calendar/event-details.html'


class EventCreateView(CreateView):
    model = Event
    template_name = 'calendar/event-add.html'
    fields = ["activity", "target_datetime", "estimated_hours", "location", "course"]


class EventUpdateView(UpdateView):
    model = Event
    template_name = 'calendar/event-edit.html'
    fields = '__all__'

widget_vincentdjango/widget_calendar/templates/calendar/calendar.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Widget's Calendar of Activities{% endblock %}
{% block heading %}
    <h1 id="header">Widget's Calendar of Activities </h1>
    <div class="separator-bar"></div>
{% endblock %}

{% block content %}
    <ul>
        {% for event in events %}
        <li class="object-cell">
            <a href="{{ event.get_absolute_url }}">
                <span class="object-title">{{ event.activity }} </span> </a>
        </li>
        {% endfor %}
    </ul>

    <button onclick="window.location.href='{% url 'calendar:event-add' %}';" class="action-button">
        New Activity
    </button>

    <div id="footer">
        <a href="{% url 'dashboard:index' %}">Dashboard</a>
        <a href="{% url 'announcements:index' %}">Announcement Board</a>
        <a href="{% url 'forum:index' %}">Forum</a>
        <a href="{% url 'assignments:homePage' %}">Assignments</a>
    </div>
{% endblock %}

widget_vincentdjango/widget_calendar/templates/calendar/event-add.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Add Activity {% endblock %}
{% block heading %}
    <h1 class="subheader"> Add a new activity: </h1>
{% endblock %}

{% block content %}
	<form method="post">
		{% csrf_token %}
		<div class="form-fields"> {{ form.as_p }} </div>
		<div class="separator-bar"></div>
		<input class="action-button" type="submit" value="Save New Activity">
	</form>
{% endblock %}

widget_vincentdjango/widget_calendar/templates/calendar/event-details.html
{% extends 'base.html' %}
{% load static %}

{% block title %} {{ object.activity }} {% endblock %}
{% block heading %}
    <h1 class="subheader"> {{ object.activity }} </h1>
{% endblock %}

{% block content %}
	<div class="separator-bar"></div>
    <div id="main">
            <p class="detail-header"> Target Date & Time: {{ event.target_datetime }} </p>
            <p class="detail-header"> Estimated Hours: {{ event.estimated_hours }} </p>
            <p class="detail-header"> Course: {{ event.course }} </p>
            <p class="detail-header"> Location: {{ event.location }} </p>
    </div>

    <div class="separator-bar"></div>
    <button class="action-button" onclick="window.location.href='{% url 'calendar:event-edit' pk=object.pk %}';">
        Edit Activity
    </button>

{% endblock %}

widget_vincentdjango/widget_calendar/templates/calendar/event-edit.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Edit Activity {% endblock %}
{% block heading %}
	<h1 class="subheader"> Edit Activity: </h1>
{% endblock %}
{% block content %}
	<form method="post">
		{% csrf_token %}
		{{ form.as_p }}
		<div class="separator-bar"></div>
		<input type="submit" value="Save New Activity" class="action-button">
	</form>
{% endblock %}